(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     29916,        797]
NotebookOptionsPosition[     29601,        781]
NotebookOutlinePosition[     30015,        799]
CellTagsIndexPosition[     29972,        796]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Define", " ", "the", " ", "deformation", " ", "gradient"}], ",", 
    " ", "F", ",", " ", 
    RowBox[{"in", " ", "terms", " ", "of", " ", "its", " ", "SVD"}], ",", " ", 
    RowBox[{"U", " ", "\[CapitalSigma]", " ", 
     RowBox[{"V", "^", "T"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"U", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"u0", ",", " ", "u3", ",", " ", "u6"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"u1", ",", " ", "u4", ",", " ", "u7"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"u2", ",", " ", "u5", ",", " ", "u8"}], "}"}]}], "}"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"V", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"v0", ",", " ", "v3", ",", " ", "v6"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"v1", ",", " ", "v4", ",", " ", "v7"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"v2", ",", " ", "v5", ",", " ", "v8"}], "}"}]}], "}"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[CapitalSigma]", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[Sigma]0", ",", " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
       
       RowBox[{"{", 
        RowBox[{"0", ",", " ", "\[Sigma]1", ",", " ", "0"}], "}"}], ",", " ", 
       
       RowBox[{"{", 
        RowBox[{"0", ",", " ", "0", ",", " ", "\[Sigma]2"}], "}"}]}], "}"}]}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"F", " ", "=", " ", 
     RowBox[{"U", ".", "\[CapitalSigma]", ".", 
      RowBox[{"Transpose", "[", "V", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Define", " ", "the", " ", "needed", " ", "invariants", " ", 
     RowBox[{"(", 
      RowBox[{"IIc", " ", "is", " ", "not", " ", "needed"}], ")"}]}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Ic", " ", "=", " ", 
     RowBox[{
      RowBox[{"\[Sigma]0", "^", "2"}], " ", "+", " ", 
      RowBox[{"\[Sigma]1", "^", "2"}], " ", "+", " ", 
      RowBox[{"\[Sigma]2", "^", "2"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"J", " ", "=", " ", 
     RowBox[{
     "\[Sigma]0", " ", "*", " ", "\[Sigma]1", " ", "*", " ", "\[Sigma]2"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Define", " ", "the", " ", "volume", " ", "Hessian"}], ",", " ", 
     "H"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"H", ":=", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "3"}], "]"}], "]"}], ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "3"}], "]"}], "]"}]}], ",", "0", ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"3", ",", "2"}], "]"}], "]"}]}], ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"3", ",", "3"}], "]"}], "]"}]}], ",", "0", ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "3"}], "]"}], "]"}], ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "2"}], "]"}], "]"}], ",", "0", ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "2"}], "]"}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "3"}], "]"}], "]"}], ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "3"}], "]"}], "]"}]}], ",", "0", ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", "0"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"3", ",", "3"}], "]"}], "]"}]}], ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "3"}], "]"}], "]"}], ",", "0", ",", "0", ",", "0",
         ",", "0", ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}]}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "3"}], "]"}], "]"}], ",", "0", ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "3"}], "]"}], "]"}]}], ",", "0", ",", "0", ",", 
        "0", ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"3", ",", "1"}], "]"}], "]"}]}], ",", "0", ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "3"}], "]"}], "]"}]}], ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "3"}], "]"}], "]"}], ",", "0", ",", "0", ",", "0",
         ",", "0", ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ",", "0"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ",", "0", ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"3", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", "0", ",", "0", ",", 
        "0"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"3", ",", "2"}], "]"}], "]"}]}], ",", "0", ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "1"}], "]"}], "]"}], ",", "0", ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ",", "0", ",", "0", ",", 
        "0"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "2"}], "]"}], "]"}]}], ",", "0", ",", 
        RowBox[{"-", 
         RowBox[{"F", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"F", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "0", ",", "0", ",", "0",
         ",", "0"}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Compute", " ", "the", " ", "eigenvalues", " ", "of", " ", "the", " ", 
     "depressed", " ", "cubic"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"alpha", " ", "=", " ", 
     RowBox[{"Ic", " ", "/", " ", "3"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"beta", " ", "=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"3", 
        RowBox[{"J", " ", "/", " ", "Ic"}]}], ")"}], 
      RowBox[{"Sqrt", "[", 
       RowBox[{"3", "/", "Ic"}], "]"}]}]}], " ", ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[CurlyEpsilon]0", " ", "=", " ", 
     RowBox[{"2", " ", "*", " ", 
      RowBox[{"Sqrt", "[", "alpha", "]"}], " ", "*", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "/", "3"}], ")"}], " ", "*", " ", 
        RowBox[{"(", 
         RowBox[{"ArcCos", "[", "beta", "]"}], ")"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[CurlyEpsilon]1", " ", "=", " ", 
     RowBox[{"2", " ", "*", " ", 
      RowBox[{"Sqrt", "[", "alpha", "]"}], " ", "*", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "/", "3"}], ")"}], " ", "*", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ArcCos", "[", "beta", "]"}], " ", "+", " ", 
          RowBox[{"2", " ", "*", " ", "Pi"}]}], ")"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[CurlyEpsilon]2", " ", "=", " ", 
     RowBox[{"2", " ", "*", " ", 
      RowBox[{"Sqrt", "[", "alpha", "]"}], " ", "*", " ", 
      RowBox[{"Cos", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "/", "3"}], ")"}], " ", "*", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ArcCos", "[", "beta", "]"}], " ", "+", " ", 
          RowBox[{"4", " ", "*", " ", "Pi"}]}], ")"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Compute", " ", "the", " ", "depressed", " ", "cubic", " ", "matrices"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"D0", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Sigma]0", " ", "*", " ", "\[Sigma]2"}], " ", "+", " ", 
          RowBox[{"\[Sigma]1", " ", "*", " ", "\[CurlyEpsilon]0"}]}], ",", 
         " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"0", ",", " ", 
         RowBox[{
          RowBox[{"\[Sigma]1", " ", "*", " ", "\[Sigma]2"}], " ", "+", " ", 
          RowBox[{"\[Sigma]0", " ", "*", " ", "\[CurlyEpsilon]0"}]}], ",", 
         " ", "0"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"0", ",", " ", "0", ",", " ", 
         RowBox[{
          RowBox[{"\[CurlyEpsilon]0", "^", "2"}], " ", "-", " ", 
          RowBox[{"\[Sigma]2", "^", "2"}]}]}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"D1", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Sigma]0", " ", "*", " ", "\[Sigma]2"}], " ", "+", " ", 
          RowBox[{"\[Sigma]1", " ", "*", " ", "\[CurlyEpsilon]1"}]}], ",", 
         " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"0", ",", " ", 
         RowBox[{
          RowBox[{"\[Sigma]1", " ", "*", " ", "\[Sigma]2"}], " ", "+", " ", 
          RowBox[{"\[Sigma]0", " ", "*", " ", "\[CurlyEpsilon]1"}]}], ",", 
         " ", "0"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"0", ",", " ", "0", ",", " ", 
         RowBox[{
          RowBox[{"\[CurlyEpsilon]1", "^", "2"}], " ", "-", " ", 
          RowBox[{"\[Sigma]2", "^", "2"}]}]}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"D2", " ", "=", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Sigma]0", " ", "*", " ", "\[Sigma]2"}], " ", "+", " ", 
          RowBox[{"\[Sigma]1", " ", "*", " ", "\[CurlyEpsilon]2"}]}], ",", 
         " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"0", ",", " ", 
         RowBox[{
          RowBox[{"\[Sigma]1", " ", "*", " ", "\[Sigma]2"}], " ", "+", " ", 
          RowBox[{"\[Sigma]0", " ", "*", " ", "\[CurlyEpsilon]2"}]}], ",", 
         " ", "0"}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{"0", ",", " ", "0", ",", " ", 
         RowBox[{
          RowBox[{"\[CurlyEpsilon]2", "^", "2"}], " ", "-", " ", 
          RowBox[{"\[Sigma]2", "^", "2"}]}]}], "}"}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Define", " ", "the", " ", "pseudo"}], "-", 
     RowBox[{"cross", " ", "product", " ", "matrices"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"D3", " ", ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0", ",", " ", "1"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", " ", 
        RowBox[{"-", "1"}], ",", " ", "0"}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"D4", " ", ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "1", ",", " ", "0"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"D5", " ", ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0", ",", " ", "1"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", " ", "0", ",", " ", "0"}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"D6", " ", ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0", ",", " ", "1"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "1", ",", " ", "0"}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"D7", " ", ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "1", ",", " ", "0"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"1", ",", " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"D8", " ", ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0", ",", " ", "1"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"0", ",", " ", "0", ",", " ", "0"}], "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"1", ",", " ", "0", ",", " ", "0"}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Compute", " ", "the", " ", "eigenvectors", " ", "of", " ", "H", " ", 
     "in", " ", "3", "x3", " ", "matrix", " ", "form"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Q0", " ", ":=", " ", 
    RowBox[{"U", " ", ".", "D0", ".", 
     RowBox[{"Transpose", "[", "V", "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"Q1", " ", ":=", " ", 
    RowBox[{"U", " ", ".", "D1", ".", 
     RowBox[{"Transpose", "[", "V", "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"Q2", " ", ":=", " ", 
    RowBox[{"U", " ", ".", "D2", ".", 
     RowBox[{"Transpose", "[", "V", "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"Q3", " ", ":=", " ", 
    RowBox[{"U", " ", ".", "D3", ".", 
     RowBox[{"Transpose", "[", "V", "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"Q4", " ", ":=", " ", 
    RowBox[{"U", " ", ".", "D4", ".", 
     RowBox[{"Transpose", "[", "V", "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"Q5", " ", ":=", " ", 
    RowBox[{"U", " ", ".", "D5", ".", 
     RowBox[{"Transpose", "[", "V", "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"Q6", " ", ":=", " ", 
    RowBox[{"U", " ", ".", "D6", ".", 
     RowBox[{"Transpose", "[", "V", "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"Q7", " ", ":=", " ", 
    RowBox[{"U", " ", ".", "D7", ".", 
     RowBox[{"Transpose", "[", "V", "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{"Q8", " ", ":=", " ", 
    RowBox[{"U", " ", ".", "D8", ".", 
     RowBox[{"Transpose", "[", "V", "]"}]}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Define", " ", "our", " ", "flattening", " ", "convention"}], " ",
     "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Vec", "[", "A_", "]"}], ":=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"A", "\[LeftDoubleBracket]", 
       RowBox[{
        RowBox[{"1", ";;", "3"}], ",", "1"}], "\[RightDoubleBracket]"}], ",", 
      
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"A", "\[LeftDoubleBracket]", 
         RowBox[{
          RowBox[{"1", ";;", "3"}], ",", "2"}], "\[RightDoubleBracket]"}], 
        ",", 
        RowBox[{"A", "\[LeftDoubleBracket]", 
         RowBox[{
          RowBox[{"1", ";;", "3"}], ",", "3"}], "\[RightDoubleBracket]"}]}], 
       "]"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Build", " ", "flattened", " ", "versions", " ", "of", " ", "the", " ", 
     "eigenvectors"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"q0", " ", ":=", " ", 
    RowBox[{"Vec", "[", "Q0", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"q1", " ", ":=", " ", 
    RowBox[{"Vec", "[", "Q1", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"q2", " ", ":=", " ", 
    RowBox[{"Vec", "[", "Q2", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"q3", " ", ":=", " ", 
    RowBox[{"Vec", "[", "Q3", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"q4", " ", ":=", " ", 
    RowBox[{"Vec", "[", "Q4", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"q5", " ", ":=", " ", 
    RowBox[{"Vec", "[", "Q5", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"q6", " ", ":=", " ", 
    RowBox[{"Vec", "[", "Q6", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"q7", " ", ":=", " ", 
    RowBox[{"Vec", "[", "Q7", "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"q8", " ", ":=", " ", 
    RowBox[{"Vec", "[", "Q8", "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
      "Define", " ", "the", " ", "assumptions", " ", "needed", " ", "by", " ", 
       RowBox[{"Simplify", "[", "]"}]}], ":", "\[IndentingNewLine]", "\t", 
      RowBox[{
       RowBox[{"-", " ", "U"}], " ", "and", " ", "V", " ", "are", " ", 
       "rotations"}]}], ",", " ", "\[IndentingNewLine]", "\t ", 
     RowBox[{
      RowBox[{"-", " ", "The"}], " ", "singular", " ", "values", " ", "are", 
      " ", "Reals"}]}], "  ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"U0", " ", "=", " ", 
     RowBox[{"U", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", " ", "1"}], "]"}], "]"}]}], ";", 
    RowBox[{"U1", " ", "=", " ", 
     RowBox[{"U", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", " ", "2"}], "]"}], "]"}]}], ";", 
    RowBox[{"U2", " ", "=", " ", 
     RowBox[{"U", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", " ", "3"}], "]"}], "]"}]}], ";", " ", 
    RowBox[{"UT0", " ", "=", " ", 
     RowBox[{"U", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "All"}], "]"}], "]"}]}], ";", 
    RowBox[{"UT1", " ", "=", " ", 
     RowBox[{"U", "[", 
      RowBox[{"[", 
       RowBox[{"2", ",", "All"}], "]"}], "]"}]}], ";", 
    RowBox[{"UT2", " ", "=", " ", 
     RowBox[{"U", "[", 
      RowBox[{"[", 
       RowBox[{"3", ",", "All"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"V0", " ", "=", " ", 
     RowBox[{"V", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", " ", "1"}], "]"}], "]"}]}], ";", 
    RowBox[{"V1", " ", "=", " ", 
     RowBox[{"V", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", " ", "2"}], "]"}], "]"}]}], ";", 
    RowBox[{"V2", " ", "=", " ", 
     RowBox[{"V", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", " ", "3"}], "]"}], "]"}]}], ";", " ", 
    RowBox[{"VT0", " ", "=", " ", 
     RowBox[{"V", "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "All"}], "]"}], "]"}]}], ";", 
    RowBox[{"VT1", " ", "=", " ", 
     RowBox[{"V", "[", 
      RowBox[{"[", 
       RowBox[{"2", ",", "All"}], "]"}], "]"}]}], ";", 
    RowBox[{"VT2", " ", "=", " ", 
     RowBox[{"V", "[", 
      RowBox[{"[", 
       RowBox[{"3", ",", "All"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"$Assumptions", " ", "=", " ", "\[IndentingNewLine]", "  ", 
      RowBox[{
       RowBox[{
        RowBox[{"U0", ".", "U1"}], " ", "\[Equal]", " ", "0"}], " ", "&&", 
       " ", 
       RowBox[{
        RowBox[{"U0", ".", "U2"}], " ", "\[Equal]", " ", "0"}], " ", "&&", 
       " ", 
       RowBox[{
        RowBox[{"U1", ".", "U2"}], " ", "\[Equal]", " ", "0"}], " ", "&&", 
       " ", 
       RowBox[{
        RowBox[{"U0", ".", "U0"}], " ", "\[Equal]", " ", "1"}], "&&", " ", 
       RowBox[{
        RowBox[{"U1", ".", "U1"}], " ", "\[Equal]", " ", "1"}], "&&", " ", 
       RowBox[{
        RowBox[{"U2", ".", "U2"}], " ", "\[Equal]", " ", "1"}], " ", "&&", 
       " ", 
       RowBox[{
        RowBox[{"UT0", ".", "UT1"}], " ", "\[Equal]", " ", "0"}], " ", "&&", 
       " ", 
       RowBox[{
        RowBox[{"UT0", ".", "UT2"}], " ", "\[Equal]", " ", "0"}], " ", "&&", 
       " ", 
       RowBox[{
        RowBox[{"UT1", ".", "UT2"}], " ", "\[Equal]", " ", "0"}], " ", "&&", 
       " ", 
       RowBox[{
        RowBox[{"UT0", ".", "UT0"}], " ", "\[Equal]", " ", "1"}], "&&", " ", 
       RowBox[{
        RowBox[{"UT1", ".", "UT1"}], " ", "\[Equal]", " ", "1"}], "&&", " ", 
       RowBox[{
        RowBox[{"UT2", ".", "UT2"}], " ", "\[Equal]", " ", "1"}], " ", "&&", 
       " ", 
       RowBox[{
        RowBox[{"V0", ".", "V1"}], "\[Equal]", "0"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{"V0", ".", "V2"}], "\[Equal]", "0"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{"V1", ".", "V2"}], "\[Equal]", "0"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{"V0", ".", "V0"}], "\[Equal]", "1"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{"V1", ".", "V1"}], "\[Equal]", "1"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{"V2", ".", "V2"}], "\[Equal]", "1"}], " ", "&&", "  ", 
       RowBox[{
        RowBox[{"VT0", ".", "VT1"}], "\[Equal]", "0"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{"VT0", ".", "VT2"}], "\[Equal]", "0"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{"VT1", ".", "VT2"}], "\[Equal]", "0"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{"VT0", ".", "VT0"}], "\[Equal]", "1"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{"VT1", ".", "VT1"}], "\[Equal]", "1"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{"VT2", ".", "VT2"}], "\[Equal]", "1"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{"Det", "[", "U", "]"}], " ", "\[Equal]", " ", "1"}], " ", "&&",
        " ", 
       RowBox[{
        RowBox[{"Det", "[", "V", "]"}], " ", "\[Equal]", "1"}], " ", "&&", 
       " ", 
       RowBox[{"\[Sigma]0", " ", "\[Element]", "Reals"}], " ", "&&", " ", 
       RowBox[{"\[Sigma]1", " ", "\[Element]", "Reals"}], " ", "&&", " ", 
       RowBox[{"\[Sigma]2", "\[Element]", "Reals"}]}]}], "}"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"For", " ", "each", " ", "eigenvector", " ", "q"}], ",", " ", 
     RowBox[{
      RowBox[{"we", " ", "now", " ", "compute", " ", "Hq"}], " ", "-", " ", 
      RowBox[{
       RowBox[{"\[Lambda]q", ".", "\[IndentingNewLine]", "If"}], " ", "q", 
       " ", "is", " ", "indeed", " ", "an", " ", "eigenvector", " ", "of", 
       " ", "H", " ", "with", " ", "eigenvalue", " ", "\[Lambda]"}]}], ",", 
     "\[IndentingNewLine]", "   ", 
     RowBox[{
     "the", " ", "resulting", " ", "vector", " ", "should", " ", "be", " ", 
      "all", " ", "zeros"}], ",", " ", 
     RowBox[{
     "and", " ", "the", " ", "norm", " ", "of", " ", "the", " ", "result", 
      " ", "should", " ", "also", " ", "be", " ", 
      RowBox[{"zero", "."}]}]}], "*)"}], " ", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<If q0 is an eigenvector, this should be zero: \>\"", " ", ",", 
      RowBox[{"Norm", "[", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"H", " ", ".", "q0"}], ")"}], " ", "-", 
         RowBox[{"\[CurlyEpsilon]0", "*", " ", "q0"}]}], "]"}], "]"}]}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<If q1 is an eigenvector, this should be zero: \>\"", " ", ",", 
      RowBox[{"Norm", "[", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"H", " ", ".", "q1"}], ")"}], " ", "-", 
         RowBox[{"\[CurlyEpsilon]1", "*", " ", "q1"}]}], "]"}], "]"}]}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<If q2 is an eigenvector, this should be zero: \>\"", " ", ",", 
      RowBox[{"Norm", "[", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"H", " ", ".", "q2"}], ")"}], " ", "-", 
         RowBox[{"\[CurlyEpsilon]2", "*", " ", "q2"}]}], "]"}], "]"}]}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<If q3 is an eigenvector, this should be zero: \>\"", " ", ",", 
      RowBox[{"Norm", "[", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"H", " ", ".", "q3"}], ")"}], " ", "-", 
         RowBox[{"\[Sigma]0", " ", "*", " ", "q3"}]}], "]"}], "]"}]}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<If q4 is an eigenvector, this should be zero: \>\"", " ", ",", 
      RowBox[{"Norm", "[", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"H", " ", ".", "q4"}], ")"}], " ", "-", 
         RowBox[{"\[Sigma]2", " ", "*", " ", "q4"}]}], "]"}], "]"}]}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<If q5 is an eigenvector, this should be zero: \>\"", " ", ",", 
      RowBox[{"Norm", "[", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"H", " ", ".", "q5"}], ")"}], " ", "-", 
         RowBox[{"\[Sigma]1", " ", "*", " ", "q5"}]}], "]"}], "]"}]}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<If q6 is an eigenvector, this should be zero: \>\"", " ", ",", 
      RowBox[{"Norm", "[", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"H", " ", ".", "q6"}], ")"}], " ", "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "\[Sigma]0"}], ")"}], " ", "*", " ", "q6"}]}], "]"}], 
       "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<If q7 is an eigenvector, this should be zero: \>\"", " ", ",", 
      RowBox[{"Norm", "[", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"H", " ", ".", "q7"}], ")"}], " ", "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "\[Sigma]2"}], ")"}], " ", "*", " ", "q7"}]}], "]"}], 
       "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{
     "\"\<If q8 is an eigenvector, this should be zero: \>\"", " ", ",", 
      RowBox[{"Norm", "[", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"H", " ", ".", "q8"}], ")"}], " ", "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "\[Sigma]1"}], ")"}], " ", "*", " ", "q8"}]}], "]"}], 
       "]"}]}], "]"}], ";"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.692715113667201*^9, 3.692715183413788*^9}, {
  3.692715214088044*^9, 3.692715245032433*^9}, {3.692715278279982*^9, 
  3.692715460566676*^9}, {3.692715509528864*^9, 3.692715550472609*^9}, {
  3.692715586244458*^9, 3.692715597541039*^9}, {3.692715686492012*^9, 
  3.692715688107326*^9}, {3.692715871727891*^9, 3.692715909003304*^9}, {
  3.6927161959342117`*^9, 3.692716201619444*^9}, {3.692716246725932*^9, 
  3.6927162468703623`*^9}, {3.692823555326473*^9, 3.6928235712761497`*^9}}]
},
WindowSize->{1193, 688},
WindowMargins->{{20, Automatic}, {23, Automatic}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
FrontEndVersion->"11.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
21, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 29039, 759, 1944, "Input"]
}
]
*)

